#ifndef __SOUND_STRINGS__
#define __SOUND_STRINGS__

#include <string>

// Menu
#define SOUND_MENU_CHANGE_MENU_ITEM     "/STATES/MENU/SOUNDS/CLICK.WAV"
#define SOUND_MENU_SELECT_MENU_ITEM     "/STATES/MENU/SOUNDS/SELECT.WAV"
#define SOUND_MENU_UNROLL               "/STATES/MENU/SOUNDS/UNROLL.WAV"
#define SOUND_MENU_DELAYUNROLL          "/STATES/MENU/SOUNDS/DELAYUNROLL.WAV"
#define SOUND_MENU_ROLLUP               "/STATES/MENU/SOUNDS/ROLLUP.WAV"
#define SOUND_MENU_COINCHING            "/STATES/MENU/SOUNDS/COINCHING.WAV"
#define SOUND_MENU_DISABLE              "/STATES/MENU/SOUNDS/DISABLE.WAV"
#define SOUND_MENU_INTRO                "/STATES/MENU/SOUNDS/INTRO.WAV"
#define SOUND_MENU_MENUMUSIC            "/STATES/MENU/SOUNDS/MENUBED.WAV"

#define SOUND_GAME_ENTER_WARP "/GAME/SOUNDS/WARP.WAV"

#define SOUND_GAME_MAPPIECE   "/GAME/SOUNDS/MAPPIECE.WAV"

#define SOUND_NULL "/GAME/SOUNDS/NULL.WAV"

// Treasure pickup sounds
#define SOUND_GAME_TREASURE_COIN        "/GAME/SOUNDS/COIN.WAV"         // 100 pts
#define SOUND_GAME_TREASURE_GOLDBAR     "/GAME/SOUNDS/TREASURE.WAV"     // 500 pts
#define SOUND_GAME_TREASURE_RING        "/GAME/SOUNDS/RINGS.WAV"        // 1500 pts
#define SOUND_GAME_TREASURE_CHALICE     "/GAME/SOUNDS/PICKUP1.WAV"      // 2500 pts
#define SOUND_GAME_TREASURE_CROSS       "/GAME/SOUNDS/CROSS.WAV"        // 5000 pts
#define SOUND_GAME_TREASURE_SCEPTER     "/GAME/SOUNDS/SCEPTER.WAV"      // 7500 pts
#define SOUND_GAME_TREASURE_GECKO       "/GAME/SOUNDS/PICKUP2.WAV"      // 10000 pts
#define SOUND_GAME_TREASURE_CROWN       "/GAME/SOUNDS/PICKUP1.WAV"      // 15000 pts
#define SOUND_GAME_TREASURE_SKULL       "/GAME/SOUNDS/PICKUP1.WAV"      // 25000 pts)

// "Rare" treasure spawned
#define SOUND_GAME_TREASURE_RARE_SPAWNED "/GAME/SOUNDS/PURELEASE1.WAV"

// Ammo pickup sounds
#define SOUND_GAME_PICKUP_AMMUNITION    "/GAME/SOUNDS/AMMUNITION.WAV"
#define SOUND_GAME_PICKUP_MAGIC         "/GAME/SOUNDS/MAGICPOWERUP.WAV"

// Extra life
#define SOUND_GAME_EXTRA_LIFE           "/GAME/SOUNDS/EXTRALIFE.WAV"

// Health pickups
#define SOUND_GAME_PICKUP_FOODITEM      "/GAME/SOUNDS/FOODITEM.WAV"
#define SOUND_GAME_PICKUP_MILK          "/GAME/SOUNDS/MILK.WAV"
#define SOUND_GAME_PICKUP_POTION        "/GAME/SOUNDS/MILK.WAV"

// Powerup pickups
#define SOUND_GAME_PICKUP_CATNIP       "/GAME/SOUNDS/CATNMAG.WAV"

// Checkpoint flags
#define SOUND_GAME_FLAG_RISE       "/GAME/SOUNDS/FLAGRISE.WAV"
#define SOUND_GAME_FLAG_WAVE       "/GAME/SOUNDS/FLAGWAVE.WAV"

// Crate death sounds
#define SOUND_GAME_CRATE_BREAK1    "/GAME/SOUNDS/CRATEBREAK.WAV"
#define SOUND_GAME_CRATE_BREAK2    "/GAME/SOUNDS/CRATEBREAK2.WAV"

// Powder keg explosion
#define SOUND_LEVEL1_KEG_EXPLODE   "/LEVEL1/SOUNDS/KEGBOOM.WAV"

// Take damage sounds
#define SOUND_LEVEL1_TAKE_DAMAGE1   "/LEVEL1/SOUNDS/HIT1.WAV"
#define SOUND_LEVEL1_TAKE_DAMAGE2   "/LEVEL1/SOUNDS/HIT2.WAV"
#define SOUND_LEVEL1_TAKE_DAMAGE3   "/LEVEL1/SOUNDS/HIT3.WAV"
#define SOUND_LEVEL1_TAKE_DAMAGE4   "/LEVEL1/SOUNDS/HIT4.WAV"

// Hit sounds
#define SOUND_GAME_HIT1    "/GAME/SOUNDS/HIT1.WAV"
#define SOUND_GAME_HIT2    "/GAME/SOUNDS/HIT2.WAV"
#define SOUND_GAME_HIT3    "/GAME/SOUNDS/HIT3.WAV"
#define SOUND_GAME_HIT4    "/GAME/SOUNDS/HIT4.WAV"

// Amulet gem rise sound
#define SOUND_GAME_AMULET_RISE "/GAME/SOUNDS/AMULETRISE.WAV"

// Captain Claw sounds

#define SOUND_CLAW_KILL_MELEE1 "/CLAW/SOUNDS/1001.WAV"
#define SOUND_CLAW_MAGIC_CLAW "/CLAW/SOUNDS/1002.WAV"
#define SOUND_CLAW_KILL_PISTOL1 "/CLAW/SOUNDS/1003.WAV"
#define SOUND_CLAW_KILL_MELEE2 "/CLAW/SOUNDS/1004A.WAV"
#define SOUND_CLAW_KILL_MELEE3 "/CLAW/SOUNDS/1004B.WAV"
#define SOUND_CLAW_LAND_LOVER1_SHORT "/CLAW/SOUNDS/1007A.WAV"
#define SOUND_CLAW_LAND_LOVER2_LONG "/CLAW/SOUNDS/1007B.WAV"
#define SOUND_CLAW_SCREW_ALL_THIS "/CLAW/SOUNDS/1009.WAV"
#define SOUND_CLAW_KILL_MELEE4 "/CLAW/SOUNDS/1010.WAV"
#define SOUND_CLAW_WOOHOO "/CLAW/SOUNDS/1021.WAV"
#define SOUND_CLAW_IDLE1 "/CLAW/SOUNDS/1054.WAV"
#define SOUND_CLAW_IDLE2 "/CLAW/SOUNDS/1055.WAV"
#define SOUND_CLAW_IDLE3 "/CLAW/SOUNDS/1056.WAV"
#define SOUND_CLAW_IDLE4 "/CLAW/SOUNDS/1057.WAV"
#define SOUND_CLAW_IDLE5 "/CLAW/SOUNDS/1058.WAV"
#define SOUND_CLAW_NOT_THIS_CAT_JACK "/CLAW/SOUNDS/1062.WAV"
#define SOUND_CLAW_PICKUP_FIRE_SWORD "/CLAW/SOUNDS/1110001.WAV"
#define SOUND_CLAW_PICKUP_FROST_SWORD "/CLAW/SOUNDS/1110012.WAV"
#define SOUND_CLAW_PICKUP_LIGHTNING_SWORD "/CLAW/SOUNDS/1110022.WAV"
#define SOUND_CLAW_HAHA "/CLAW/SOUNDS/1110033.WAV"
#define SOUND_CLAW_IDLE6 "/CLAW/SOUNDS/1110035.WAV"
#define SOUND_CLAW_IDLE7 "/CLAW/SOUNDS/1110037.WAV"
#define SOUND_CLAW_IDLE8 "/CLAW/SOUNDS/1110038.WAV"
#define SOUND_CLAW_IDLE9 "/CLAW/SOUNDS/1110043.WAV"
#define SOUND_CLAW_IDLE10 "/CLAW/SOUNDS/1110045.WAV"
#define SOUND_CLAW_TAKE_DAMAGE1 "/CLAW/SOUNDS/1110048.WAV"
#define SOUND_CLAW_TAKE_DAMAGE2 "/CLAW/SOUNDS/1110049.WAV"
#define SOUND_CLAW_TAKE_DAMAGE3 "/CLAW/SOUNDS/1110050.WAV"
#define SOUND_CLAW_TAKE_DAMAGE4 "/CLAW/SOUNDS/1110051.WAV"
#define SOUND_CLAW_IDLE11 "/CLAW/SOUNDS/1110056.WAV"
#define SOUND_CLAW_IDLE12 "/CLAW/SOUNDS/1110057.WAV"
#define SOUND_CLAW_KILL_MELEE5 "/CLAW/SOUNDS/1110058.WAV"
#define SOUND_CLAW_KILL_MELEE6 "/CLAW/SOUNDS/1110059.WAV"
#define SOUND_CLAW_YES_LONG "/CLAW/SOUNDS/1110063.WAV"
#define SOUND_CLAW_YES_SHORT "/CLAW/SOUNDS/1110064.WAV"
#define SOUND_CLAW_DEATH_CONVENTIONAL "/CLAW/SOUNDS/FALLDEATH.WAV"
#define SOUND_CLAW_DEATH_SPIKES "/LEVEL1/SOUNDS/DEATHTILE.WAV"

#define SOUND_CLAW_FIRE_SWORD "/CLAW/SOUNDS/FIRESWORD.WAV"
#define SOUND_CLAW_FROST_SWORD "/CLAW/SOUNDS/ICESWORD.WAV"
#define SOUND_CLAW_LIGHTNING_SWORD "/CLAW/SOUNDS/LIGHTSWORD.WAV"

#define SOUND_CLAW_LAND_SHORT "/CLAW/SOUNDS/LEFTFOOT1.WAV"

// NOTE: Other Claw sound strings should be embedded into anis

// Fade in/out sounds
#define SOUND_GAME_DEATH_FADE_IN_SOUND "/GAME/SOUNDS/CIRCLEFADE.WAV"
#define SOUND_GAME_DEATH_FADE_OUT_SOUND "/GAME/SOUNDS/FLAGWAVE.WAV"

// LEVEL 1 enemy sounds

// LEVEL1 - Soldier
#define SOUND_LEVEL1_SOLDIER_DEATH         "/LEVEL1/SOUNDS/SOLDIER/00320006.WAV"
#define SOUND_LEVEL1_SOLDIER_DAMAGED       "/LEVEL1/SOUNDS/SOLDIER/00320005.WAV"
#define SOUND_LEVEL1_SOLDIER_THROWN        "/LEVEL1/SOUNDS/SOLDIER/00340016.WAV"
#define SOUND_LEVEL1_SOLDIER_ENTER_AGGRO   "/LEVEL1/SOUNDS/SOLDIER/00320020.WAV"
#define SOUND_LEVEL1_SOLDIER_MELEE_ATTACK  "/LEVEL1/SOUNDS/SOLDIER/RFHEADBT8-22.WAV"
#define SOUND_LEVEL1_SOLDIER_SHOOT         "/LEVEL1/SOUNDS/SOLDIER/SOLGUNFR8-22.WAV"

// LEVEL1 - Officer
#define SOUND_LEVEL1_OFFICER_DEATH1        "/LEVEL1/SOUNDS/OFFICER/00340014.WAV"
#define SOUND_LEVEL1_OFFICER_DEATH2        "/LEVEL1/SOUNDS/OFFICER/00340015.WAV"
#define SOUND_LEVEL1_OFFICER_THROWN1       "/LEVEL1/SOUNDS/OFFICER/00340017.WAV"
#define SOUND_LEVEL1_OFFICER_THROWN2       "/LEVEL1/SOUNDS/OFFICER/00340018.WAV"
#define SOUND_LEVEL1_OFFICER_ENTER_AGRO    "/LEVEL1/SOUNDS/OFFICER/00340024.WAV"
#define SOUND_LEVEL1_OFFICER_HA_TOUCHE     "/LEVEL1/SOUNDS/OFFICER/00340027.WAV"
#define SOUND_LEVEL1_OFFICER_EHM1          "/LEVEL1/SOUNDS/OFFICER/EHEM1.WAV"
#define SOUND_LEVEL1_OFFICER_EHM2          "/LEVEL1/SOUNDS/OFFICER/EHEM2.WAV"
#define SOUND_LEVEL1_OFFICER_MELEE_ATTACK  "/LEVEL1/SOUNDS/OFFICER/OFCSWSTB8-22.WAV"

// LEVEL1 - Rat
#define SOUND_LEVEL1_RAT_DEATH             "/GAME/SOUNDS/MOUSEKILL.WAV"
#define SOUND_LEVEL1_RAT_THROW_BOMB        "/GAME/SOUNDS/THRWBOMB.WAV"

#define SOUND_LEVEL1_PEG_CRUMBLE           "/LEVEL1/SOUNDS/PEGCRUMBLE.WAV"

// Level 2 Boss - LaRaux
#define SOUND_LEVEL2_BOSS_DEAD             "/LEVEL2/SOUNDS/RAUX/00840005.WAV"



#endif